#komendy wykonywane co tick do obsługi stanów
#na świecie powinien być byt o UUID:7772696d-706c-0000-0000-000000000001
#z ustawioną wartością w scoreboardzie engine
#jeśli go nie ma, należy ręcznie odpalić funkcję start

#obsługa triggerów

#to powinno być z automatu, a nie jako przepisanie
#ale będzie jako przepisanie, żeby się nie zmieniało do końca ticku
scoreboard players operation @e[name=znacznik,c=1] engine = state engine

#drużyny według tagów
scoreboard teams empty ingame
scoreboard teams empty spectator
execute @s[score_debug_min=1] ~ ~ ~ scoreboard teams join ingame @a[tag=ingame,team=]
execute @s[score_debug_min=1] ~ ~ ~ scoreboard teams join spectator @a[tag=spectator,team=]

#obsługa gracza, który właśnie wszedł na serwer
#execute @a[score_joined_min=1]

#shift detector
execute @a ~ ~ ~ function wrimpl:shiftdetector/work
execute @s[score_debug_min=1] ~ ~ ~ execute @a[score_wrimpl_shifts_min=7] ~ ~ ~ function sorcerersbook:engine/awaryjne_wyjscie

#ustawienie biomu na 0 z powrotem na zaś - niby powinno działać, ale czasem nie działa
#TODO
execute @a[score_biome_min=1,x=1000,y=100,z=1000,r=100,tag=!ingame] ~ ~ ~ function sorcerersbook:reset_spells
scoreboard players set @a[score_biome_min=1,x=1000,y=100,z=1000,r=100,tag=!ingame] biome 0
scoreboard players set @a[x=1000,y=100,z=1000,rm=101,r=256,tag=!ingame] biome 1
scoreboard players tag @a remove lobby
scoreboard players tag @a[score_biome_min=1,x=1000,y=100,z=1000,r=100] add lobby

#hotbary - jeśli był w teleportastic to przywracamy mu zaklęcia
clear @a[score_joined_min=1,score_tp_mode_min=1]
execute @a[score_joined_min=1,score_tp_mode_min=1] ~ ~ ~ function sorcerersbook:engine/hotbar/load_hotbar
scoreboard players set @a[score_joined_min=1,score_tp_mode_min=1] tp_mode 0

#tutaj są wszystkie możliwe stany rozbite na osobne funkcje
#0, 1, 2, 3 - lobby
execute @s[score_engine_min=0,score_engine=0] ~ ~ ~ function sorcerersbook:engine/work0
execute @s[score_engine_min=1,score_engine=1] ~ ~ ~ function sorcerersbook:engine/work1
execute @s[score_engine_min=2,score_engine=2] ~ ~ ~ function sorcerersbook:engine/work2
execute @s[score_engine_min=3,score_engine=3] ~ ~ ~ function sorcerersbook:engine/work3
execute @s[score_engine_min=4,score_engine=4] ~ ~ ~ function sorcerersbook:engine/work4

#10, 11 - pvp
execute @s[score_engine_min=10,score_engine=10] ~ ~ ~ function sorcerersbook:engine/work10
execute @s[score_engine_min=11,score_engine=11] ~ ~ ~ function sorcerersbook:engine/work11

#20, 21 - team pvp
execute @s[score_engine_min=20,score_engine=20] ~ ~ ~ function sorcerersbook:engine/work20
execute @s[score_engine_min=21,score_engine=21] ~ ~ ~ function sorcerersbook:engine/work21

#30, 31 - teleportacyjne
execute @s[score_engine_min=30,score_engine=30] ~ ~ ~ function sorcerersbook:engine/work30
execute @s[score_engine_min=31,score_engine=31] ~ ~ ~ function sorcerersbook:engine/work31

#40, 41 - pve
execute @s[score_engine_min=40,score_engine=40] ~ ~ ~ function sorcerersbook:engine/work40
execute @s[score_engine_min=41,score_engine=41] ~ ~ ~ function sorcerersbook:engine/work41

#zmiana gamemode tym, którzy mają niepoprawny
execute @a[tag=!ingame] ~ ~ ~ execute @s[tag=!spectator] ~ ~ ~ scoreboard players set @s[tag=!cziter] gamemode 2

#reset deathcounter nieżywym graczom - tak na zaś, jeśli wcześniej nikt tego nie zrobił
scoreboard players reset @a[score_engine_deaths_min=1] engine_deaths

#reset triggerow - reset następuje dla graczy, którzy mieli inne wartości triggerów
scoreboard players reset @a[score_engine_trigger_min=1] engine_trigger

#reset triggerow (tylko enable)
scoreboard players enable @a engine_trigger

#wywalanie z drużyn niegraczy
execute @a[tag=!spectator] ~ ~ ~ scoreboard teams leave @s[tag=!ingame]

#usuwanie bloku gateway - uwaga! chmurka musi mieć Duration minimum 80!
scoreboard players tag @e[type=area_effect_cloud,tag=beam] add beam_end {Age:79}
execute @e[type=area_effect_cloud,tag=beam_end] ~ ~ ~ setblock ~ ~ ~ air

#ustawianie many - teamy - debug
#scoreboard players set @a[team=!] biome 1
#scoreboard players set @a[team=blue,x=4961,y=200,z=968,r=5] biome 0
#kill @a[team=red,x=4961,y=200,z=968,r=5]
#scoreboard players set @a[team=red,x=5050,y=200,z=1050,r=5] biome 0
#kill @a[team=blue,x=5050,y=200,z=1050,r=5]

#rozszerzony hotbar
#execute @a ~ ~ ~ function sorcerersbook:engine/hotbar/hotbar_work

#teleportacja graczy, którzy są nie tam, gdzie trzeba
execute @a[tag=!cziter] ~ ~ ~ detect ~ 100 ~ barrier 0 tp @s ~ 1000 ~
#function sorcerersbook:engine/teleportacja

#animacja tytułu mapy
scoreboard players add @s wither 5
scoreboard players set @s[score_wither_min=140] wither 0
execute @s[score_wither_min=0,score_wither=9] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§dS§d§5orcerer's Book 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=10,score_wither=19] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5S§do§d§5rcerer's Book 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=20,score_wither=29] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5So§dr§d§5cerer's Book 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=30,score_wither=39] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sor§dc§d§5erer's Book 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=40,score_wither=49] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sorc§de§d§5rer's Book 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=50,score_wither=59] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sorce§dr§d§5er's Book 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=60,score_wither=69] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sorcer§de§d§5r's Book 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=70,score_wither=79] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sorcere§dr§d§5's Book 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=80,score_wither=89] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sorcerer§d's§d§5 Book 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=90,score_wither=99] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sorcerer's §dB§d§5ook 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=100,score_wither=109] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sorcerer's B§do§d§5ok 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=110,score_wither=119] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sorcerer's Bo§do§d§5k 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=120,score_wither=129] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sorcerer's Boo§dk§d§5 2 §r- §f§lCmdBlock§c§lPL"}
execute @s[score_wither_min=130,score_wither=139] ~ ~ ~ entitydata @e[type=wither] {CustomName:"§d§5Sorcerer's Book §d2§d§5 §r- §f§lCmdBlock§c§lPL"}
